VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Please Select File for Manifest Creation"
   ClientHeight    =   6420
   ClientLeft      =   30
   ClientTop       =   315
   ClientWidth     =   6630
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6420
   ScaleWidth      =   6630
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   188
      TabIndex        =   3
      Top             =   143
      Width           =   2415
   End
   Begin VB.DirListBox Dir1 
      Height          =   2115
      Left            =   188
      TabIndex        =   2
      Top             =   623
      Width           =   6135
   End
   Begin VB.FileListBox File1 
      Height          =   1455
      Left            =   188
      Pattern         =   "*.ism"
      TabIndex        =   1
      Top             =   3023
      Width           =   6255
   End
   Begin VB.CommandButton Manifest 
      Caption         =   "Please Select ISM File for Mainfest Creation"
      Height          =   1455
      Left            =   188
      MaskColor       =   &H0000FF00&
      TabIndex        =   0
      Top             =   4823
      Width           =   6255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim intLogFileNum As Integer
Dim oISM, top_Feature
Dim feature, component, file, LogFile
Dim ProjectName, File1Path, Dir1Path, Drive1Path, PathName
'Define the Location to write the output file for Debugging
'Const LogFile As String = "c:\temp\manif.txt"
Private Sub Drive1_Change()

Drive1.Refresh

Dir1.Path = Drive1.Drive
File1.Path = Dir1.Path
Manifest.Caption = "Please Select ISM File for Manifest Creation"

Dir1.Refresh
File1.Refresh

End Sub
Private Sub Dir1_Change()

File1.Path = Dir1.Path
Manifest.Caption = "Please Select ISM File for Manifest Creation"

File1.Refresh

End Sub
Private Sub File1_Click()

ProjectName = File1.FileName
PathName = File1.Path

Manifest.Caption = "Make Manifest of All Files in " + File1.Path + File1.FileName

End Sub
Private Sub Manifest_Click()

Call create_manifest

End Sub

' The output file from this routine is in the format
' File;Source;Destination;Feature and includes the quotes
' around the path in the file.
' The output is easy to import into spreadsheet programs,
' simply set to use commas AND " as separator characters,
' and ignore two consecutive separators.


Sub create_manifest()

Form1.MousePointer = 11

Set oISM = CreateObject("ISWiAutomation.ISWiProject")

'MsgBox ("Project name is " + PathName + "\" + ProjectName)

LogFile = PathName + "\" + ProjectName + "_manifest.txt"

oISM.OpenProject PathName + "\" + ProjectName

intLogFileNum = FreeFile()

Open LogFile For Output As #intLogFileNum

' First line of the file is an explanation of the format used
Print #intLogFileNum, "File; Source; Destination; Feature;"

'Writes out the top-level Feature name to the file, then calls out
'to list each of the components in the feature.
For Each top_Feature In oISM.ISWiFeatures

    Print #intLogFileNum, top_Feature.Name & ";XXXXXXXXXXXXXXX;" & "XXXXXXXXXXXXXXX;" & "XXXXXXXXXXXXXXX;" & "XXXXXXXXXXXXXXX;"
    
    Call EnumFilesInFeatureAndSubfeatures(top_Feature)

Next ' top_feature

oISM.CloseProject

Close #intLogFileNum

Set oISM = Nothing

Form1.MousePointer = 0

'Put up a message box at the end to indicate completion.
MsgBox ("Manifest Creation Complete.")

End Sub

Private Sub EnumFilesInFeatureAndSubfeatures(top_Feature)

' This function writes out each component's file name, source
' destination, and what feature contains the component.
' Components are broken into groups by top-level Feature.
' The sections are separated by a line containing
' mostly Xs and the Feature Name. (as defined above)

For Each component In top_Feature.ISWiComponents

    For Each file In component.ISWiFiles

        Print #intLogFileNum, file.DisplayName & ";""" & file.FullPath & _
         """;[" & _
         Right(component.Destination, Len(component.Destination) - 1) & _
         ";" & top_Feature.Name & ";" & component.Name & ";"

    Next ' file
    
Next ' component

    For Each feature In top_Feature.Features
    
        Call EnumFilesInFeatureAndSubfeatures(feature)
            
    Next ' feature


End Sub


